#
# vdsm-jsonrpc-java - vdsm json rpc
# Copyright (C) 2013-2016 Red Hat, Inc.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
#

%global		package_version 1.2.7
%global		package_maven_version 1.2.7

%if 0%{?fedora:1}
%global	_use_maven 1
%endif
%if 0%{?rhel:1}
%global	_mvn_opts -Pno-test
%global        _use_maven 0
%global        _use_repolib 1
%global        maven2brewrepodir %{_javadir}/repository.jboss.com/maven2-brew/dummy
%endif

Summary:	JsonRpc java client (%{name}) for oVirt
Name:		vdsm-jsonrpc-java
Version:	1.2.7
Release:	1%{?release_suffix}%{?dist}
License:	LGPLv2+
URL:		http://www.ovirt.org
Source:		http://resources.ovirt.org/pub/ovirt-3.6-snapshot/src/%{name}/%{name}-%{package_version}.tar.gz
Group:		Development/Libraries

BuildArch:	noarch


BuildRequires:	jackson >= 1.9
BuildRequires:	java-devel >= 1.7.0
BuildRequires:	slf4j >= 1.7.0

%if %{_use_maven}
BuildRequires:	junit
BuildRequires:	maven-compiler-plugin
BuildRequires:	maven-enforcer-plugin
BuildRequires:	maven-install-plugin
BuildRequires:	maven-jar-plugin
BuildRequires:	maven-javadoc-plugin
BuildRequires:	maven-local
BuildRequires:	maven-source-plugin
BuildRequires:	maven-surefire-provider-junit
BuildRequires:	mockito
%endif

Requires:	jackson >= 1.9
Requires:	java-openjdk >= 1.7.0
Requires:	slf4j >= 1.7.0

%description
vdsm jsonrpc java

%if %{_use_maven}
%package javadoc
Summary:	Java-docs for %{name}
Group:		Documentation

%description javadoc
This package contains the API documentation for %{name}.
%endif

%if 0%{?_use_repolib:1}
%package repolib
Summary:       %{name} maven repo
%description repolib
%{name} maven repo
%endif

%prep
%setup -q -n %{name}-%{package_version}

%build
%if %{_use_maven}
%global conf --with-maven --disable-java-build
%else
%global conf \\\
	JACKSON_CORE_ASL=$(build-classpath jackson/jackson-core-asl) \\\
	JACKSON_MAPPER_ASL=$(build-classpath jackson/jackson-mapper-asl) \\\
	SLF4J_JAR=$(build-classpath slf4j) \\\
	JAVAC=/usr/lib/jvm/java-1.7.0/bin/javac \\\
	JAR=/usr/lib/jvm/java-1.7.0/bin/jar \\\
	%{?null}
%endif
%configure %{?conf}
make %{?_smp_mflags}

%if %{_use_maven}
%mvn_build -- %{?_mvn_opts}
%endif

%install
%if 0%{?_use_repolib:1}
rm -rf "%{buildroot}"
%endif
make %{?_smp_mflags} install DESTDIR="%{buildroot}"

%if %{_use_maven}
%mvn_install
%else
install -d "%{buildroot}%{_javadir}/%{name}"
FILE=$(ls -1 target/%{name}-client*.jar | grep -v source | grep -v javadoc | xargs -n 1 basename)
install target/$FILE %{buildroot}%{_javadir}/%{name}
ln -s $FILE %{buildroot}%{_javadir}/%{name}/%{name}-client.jar
%endif

%if 0%{?_use_repolib:1}
install -d "%{buildroot}%{maven2brewrepodir}/root"
install -d "%{buildroot}%{maven2brewrepodir}/%{name}"
cp pom.xml "%{buildroot}%{maven2brewrepodir}/root/root-%{package_maven_version}.pom"
cp "%{buildroot}%{_javadir}/%{name}/%{name}-client.jar" "%{buildroot}%{maven2brewrepodir}/%{name}/%{name}-client-%{package_maven_version}.jar"
cp client/pom.xml "%{buildroot}%{maven2brewrepodir}/%{name}/%{name}-client-%{package_maven_version}.pom"
%endif

%if %{_use_maven}
%files -f .mfiles
%dir %{_javadir}/%{name}
%else
%files
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/%{name}*.jar
%endif

%if %{_use_maven}
%files javadoc -f .mfiles-javadoc
%endif

%if 0%{?_use_repolib:1}
%files repolib
%{maven2brewrepodir}/
%endif

%changelog
* Fri Oct 28 2016 Piotr Kliczewski <pkliczew@redhat.com> 1.2.7
- do not reconnect to policy reset

* Wed Oct 12 2016 Piotr Kliczewski <pkliczew@redhat.com> 1.2.6
- make sure that channel is protected by the lock

* Wed Jun 29 2016 Piotr Kliczewski <pkliczew@redhat.com> 1.2.5
- wait on close

* Tue Jun 28 2016 Piotr Kliczewski <pkliczew@redhat.com> 1.2.4
- schedule close when we reset policy

* Tue May 31 2016 Piotr Kliczewski <pkliczew@redhat.com> 1.2.3
- Release of 1.2.3

* Fri May 6 2016 Piotr Kliczewski <pkliczew@redhat.com> 1.2.3
- cleanup tracked request on demand

* Mon May 02 2016 Piotr Kliczewski <pkliczew@redhat.com> 1.2.2-1
- timing issue during setup networks
- send control frames first
- connect: queue messages for sending
- process issue for events and responses
- provide connection identifier

* Wed Feb 24 2016 Piotr Kliczewski <pkliczew@redhat.com> 1.2.1-4
- timeout on sending connect frame
- make sure no password in the logs

* Fri Feb 19 2016 Piotr Kliczewski <pkliczew@redhat.com> 1.2.1-3
- restore repolib

* Fri Feb 19 2016 Piotr Kliczewski <pkliczew@redhat.com> 1.2.1-2
- align dependencies with el7

* Mon Feb 8 2016 Piotr Kliczewski <pkliczew@redhat.com> 1.2.1
- Initial release of 4.0

* Tue Jan 19 2016 Piotr Kliczewski <pkliczew@redhat.com> 1.1.7-1
- Exception shouldn't be recursive

* Fri Jan 8 2016 Piotr Kliczewski <pkliczew@redhat.com> 1.1.6-1
- scheduled tasks do not check whether a channel is there
- i/o thread blocked during connection

* Thu Sep 24 2015 Piotr Kliczewski <pkliczew@redhat.com> 1.1.5-1
- Releasing for RC

* Wed Jul 15 2015 Piotr Kliczewski <pkliczew@redhat.com 1.1.4
- Update report ceritification expiration date
- Fix spelling mistake

* Sun Jul 5 2015 Piotr Kliczewski <pkliczew@redhat.com 1.1.3-2
- Version update

* Wed Jul 1 2015 Piotr Kliczewski <pkliczew@redhat.com> 1.1.3-1
- Matching side effect fix
- Report certification expiration date

* Wed Jun 10 2015 Piotr Kliczewski <pkliczew@redhat.com> 1.1.2-1
- Introduced new queue for events

* Mon Apr 20 2015 Piotr Kliczewski <pkliczew@redhat.com> 1.1.1
- Introduction of Events

* Tue Apr 7 2015 Piotr Kliczewski <pkliczew@redhat.com> 1.1.0
- Initial release for 3.6
